<?php

namespace App\domain\amadeus;

class PaymentFlowAction
{
    protected createFOPAction $createFOPAction;
    protected queryFarePricePNRWithBookingClassAction $queryFarePricePNRWithBookingClassAction;
    protected CreateTSTFromPricing $CreateTSTFromPricing;
    protected PNRAddMultiElementsSecondAction $PNRAddMultiElementsSecondAction;
    protected QuerySecuritySignOut $securitySignOut;

    public function __construct()
    {
        $this->createFOPAction = new createFOPAction;
        $this->queryFarePricePNRWithBookingClassAction = new queryFarePricePNRWithBookingClassAction;
        $this->CreateTSTFromPricing = new CreateTSTFromPricing;
        $this->PNRAddMultiElementsSecondAction = new PNRAddMultiElementsSecondAction;
        $this->securitySignOut = new QuerySecuritySignOut;
    }

    public function execute(
        string $amadeusSessionId,
        string $amadeusSecurityToken,
        string $payType,
        string $otherCompany,
        array  $passengerCriteria
    ): array
    {
        $this->createFOPAction->execute($payType, $amadeusSessionId, $amadeusSecurityToken);
        $this->queryFarePricePNRWithBookingClassAction->execute($otherCompany, $amadeusSessionId, $amadeusSecurityToken);
        $this->CreateTSTFromPricing->execute($passengerCriteria, $amadeusSessionId, $amadeusSecurityToken);
        $responseWithControlNumber = $this->PNRAddMultiElementsSecondAction->execute($amadeusSessionId, $amadeusSecurityToken);
        $this->securitySignOut->execute($amadeusSessionId, $amadeusSecurityToken);

        return $responseWithControlNumber;
    }
}
