<?php

namespace App\domain\amadeus\traits;

use Illuminate\Support\Carbon;

trait AmadeusDateConversionTrait
{
    public function getCarbonDateTime(string $date, string $time): Carbon
    {
        $day = substr($date, 0, 2);
        $month = substr($date, 2, 2);
        $year = "20" . substr($date, 4);
        $hour = substr($time, 0, 2);
        $minute = substr($time, 2);

        return Carbon::create($year, $month, $day, $hour, $minute,0,"UTC");
    }

    public function getDurationString(float $durationInHours): string
    {
        $hours = floor($durationInHours);
        $minutes = round(($durationInHours - $hours) * 60);

        return 'PT' . $hours . 'H' . $minutes . 'M';
    }

    public function getDurationInHours(Carbon $originDepartureTime, Carbon $destinationArrivalTime): int|float
    {
        $diffInMinutes = $originDepartureTime->diffInMinutes($destinationArrivalTime);

        return $diffInMinutes / 60;
    }
}
